bin/idea.sh
author vlivanov
Thu, 18 Jan 2018 02:25:18 +0300
changeset 48596 860326263d1f
parent 47217 72e3ae9a25eb
child 48667 f2344724a475
permissions -rw-r--r--
8194963: SystemDictionary::link_method_handle_constant() can't link MethodHandle.invoke()/invokeExact() Reviewed-by: kvn, psandoz
Ignore whitespace changes - Everywhere: Within whitespace: At end of lines:
37861
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
     1
#!/bin/sh
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
     2
#
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
     3
# Copyright (c) 2009, 2014, Oracle and/or its affiliates. All rights reserved.
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
     4
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
     5
#
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
     6
# This code is free software; you can redistribute it and/or modify it
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
     7
# under the terms of the GNU General Public License version 2 only, as
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
     8
# published by the Free Software Foundation.
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
     9
#
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    10
# This code is distributed in the hope that it will be useful, but WITHOUT
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    11
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    12
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    13
# version 2 for more details (a copy is included in the LICENSE file that
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    14
# accompanied this code).
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    15
#
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    16
# You should have received a copy of the GNU General Public License version
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    17
# 2 along with this work; if not, write to the Free Software Foundation,
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    18
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    19
#
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    20
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    21
# or visit www.oracle.com if you need additional information or have any
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    22
# questions.
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    23
#
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    24
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    25
# Shell script for generating an IDEA project from a given list of modules
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    26
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    27
usage() {
47217
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
    28
      echo "usage: $0 [-h|--help] [-v|--verbose] [-o|--output <path>] [modules]+"
37861
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    29
      exit 1
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    30
}
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    31
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    32
SCRIPT_DIR=`dirname $0`
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    33
PWD=`pwd`
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    34
cd $SCRIPT_DIR; SCRIPT_DIR=`pwd`
47217
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
    35
cd ../; TOP=`pwd`; cd $PWD
37861
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    36
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    37
IDEA_OUTPUT=$TOP/.idea
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    38
VERBOSE="false"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    39
while [ $# -gt 0 ]
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    40
do
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    41
  case $1 in
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    42
    -h | --help )
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    43
      usage
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    44
      ;;
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    45
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    46
    -v | --vebose )
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    47
      VERBOSE="true"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    48
      ;;
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    49
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    50
    -o | --output )
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    51
      IDEA_OUTPUT=$2
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    52
      shift
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    53
      ;;
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    54
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    55
    -*)  # bad option
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    56
      usage
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    57
      ;;
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    58
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    59
     * )  # non option
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    60
      break
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    61
      ;;
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    62
  esac
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    63
  shift
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    64
done
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    65
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    66
mkdir $IDEA_OUTPUT || exit 1
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    67
cd $IDEA_OUTPUT; IDEA_OUTPUT=`pwd`
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    68
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    69
IDEA_MAKE="$TOP/make/idea"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    70
IDEA_TEMPLATE="$IDEA_MAKE/template"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    71
IML_TEMPLATE="$IDEA_TEMPLATE/jdk.iml"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    72
ANT_TEMPLATE="$IDEA_TEMPLATE/ant.xml"
47217
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
    73
MISC_TEMPLATE="$IDEA_TEMPLATE/misc.xml"
37861
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    74
IDEA_IML="$IDEA_OUTPUT/jdk.iml"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    75
IDEA_ANT="$IDEA_OUTPUT/ant.xml"
47217
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
    76
IDEA_MISC="$IDEA_OUTPUT/misc.xml"
37861
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    77
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    78
if [ "$VERBOSE" = "true" ] ; then
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    79
  echo "output dir: $IDEA_OUTPUT"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    80
  echo "idea template dir: $IDEA_TEMPLATE"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    81
fi
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    82
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    83
if [ ! -f "$IML_TEMPLATE" ] ; then
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    84
  echo "FATAL: cannot find $IML_TEMPLATE" >&2; exit 1
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    85
fi
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    86
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    87
if [ ! -f "$ANT_TEMPLATE" ] ; then
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    88
  echo "FATAL: cannot find $ANT_TEMPLATE" >&2; exit 1
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    89
fi
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    90
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    91
cp -r "$IDEA_TEMPLATE"/* "$IDEA_OUTPUT"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    92
cd $TOP ; make -f "$IDEA_MAKE/idea.gmk" -I make/common idea MAKEOVERRIDES= OUT=$IDEA_OUTPUT/env.cfg MODULES="$*" || exit 1
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    93
cd $SCRIPT_DIR
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    94
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    95
. $IDEA_OUTPUT/env.cfg
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    96
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    97
# Expect MODULE_ROOTS, MODULE_NAMES, BOOT_JDK & SPEC to be set
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    98
if [ "x$MODULE_ROOTS" = "x" ] ; then
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
    99
  echo "FATAL: MODULE_ROOTS is empty" >&2; exit 1
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   100
fi
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   101
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   102
if [ "x$MODULE_NAMES" = "x" ] ; then
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   103
  echo "FATAL: MODULE_NAMES is empty" >&2; exit 1
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   104
fi
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   105
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   106
if [ "x$BOOT_JDK" = "x" ] ; then
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   107
  echo "FATAL: BOOT_JDK is empty" >&2; exit 1
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   108
fi
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   109
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   110
if [ "x$SPEC" = "x" ] ; then
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   111
  echo "FATAL: SPEC is empty" >&2; exit 1
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   112
fi
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   113
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   114
SOURCE_FOLDER="      <sourceFolder url=\"file://\$MODULE_DIR\$/####\" isTestSource=\"false\" />"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   115
SOURCE_FOLDERS_DONE="false"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   116
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   117
addSourceFolder() {
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   118
  root=$@
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   119
  relativePath="`echo "$root" | sed -e s@"$TOP/\(.*$\)"@"\1"@`"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   120
  folder="`echo "$SOURCE_FOLDER" | sed -e s@"\(.*/\)####\(.*\)"@"\1$relativePath\2"@`"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   121
  printf "%s\n" "$folder" >> $IDEA_IML
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   122
}
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   123
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   124
### Generate project iml
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   125
rm -f $IDEA_IML
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   126
while IFS= read -r line
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   127
do
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   128
  if echo "$line" | egrep "^ .* <sourceFolder.*####" > /dev/null ; then
47217
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   129
    if [ "$SOURCE_FOLDERS_DONE" = "false" ] ; then
37861
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   130
      SOURCE_FOLDERS_DONE="true"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   131
      for root in $MODULE_ROOTS; do
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   132
         addSourceFolder $root
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   133
      done
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   134
    fi
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   135
  else
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   136
    printf "%s\n" "$line" >> $IDEA_IML
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   137
  fi
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   138
done < "$IML_TEMPLATE"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   139
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   140
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   141
MODULE_NAME="        <property name=\"module.name\" value=\"####\" />"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   142
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   143
addModuleName() {
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   144
  mn="`echo "$MODULE_NAME" | sed -e s@"\(.*\)####\(.*\)"@"\1$MODULE_NAMES\2"@`"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   145
  printf "%s\n" "$mn" >> $IDEA_ANT
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   146
}
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   147
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   148
BUILD_DIR="        <property name=\"build.target.dir\" value=\"####\" />"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   149
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   150
addBuildDir() {
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   151
  DIR=`dirname $SPEC`
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   152
  mn="`echo "$BUILD_DIR" | sed -e s@"\(.*\)####\(.*\)"@"\1$DIR\2"@`"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   153
  printf "%s\n" "$mn" >> $IDEA_ANT
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   154
}
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   155
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   156
### Generate ant.xml
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   157
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   158
rm -f $IDEA_ANT
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   159
while IFS= read -r line
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   160
do
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   161
  if echo "$line" | egrep "^ .* <property name=\"module.name\"" > /dev/null ; then
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   162
    addModuleName
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   163
  elif echo "$line" | egrep "^ .* <property name=\"build.target.dir\"" > /dev/null ; then
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   164
    addBuildDir
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   165
  else
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   166
    printf "%s\n" "$line" >> $IDEA_ANT
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   167
  fi
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   168
done < "$ANT_TEMPLATE"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   169
47217
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   170
### Generate misc.xml
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   171
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   172
rm -f $IDEA_MISC
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   173
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   174
JTREG_HOME="    <path>####</path>"
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   175
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   176
IMAGES_DIR="    <jre alt=\"true\" value=\"####\" />"
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   177
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   178
addImagesDir() {
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   179
  DIR=`dirname $SPEC`/images/jdk
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   180
  mn="`echo "$IMAGES_DIR" | sed -e s@"\(.*\)####\(.*\)"@"\1$DIR\2"@`"
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   181
  printf "%s\n" "$mn" >> $IDEA_MISC
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   182
}
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   183
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   184
addJtregHome() {
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   185
  DIR=`dirname $SPEC`
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   186
  mn="`echo "$JTREG_HOME" | sed -e s@"\(.*\)####\(.*\)"@"\1$JT_HOME\2"@`"
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   187
  printf "%s\n" "$mn" >> $IDEA_MISC
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   188
}
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   189
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   190
rm -f $MISC_ANT
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   191
while IFS= read -r line
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   192
do
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   193
  if echo "$line" | egrep "^ .*<path>jtreg_home</path>" > /dev/null ; then
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   194
	addJtregHome
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   195
  elif echo "$line" | egrep "^ .*<jre alt=\"true\" value=\"images_jdk\"" > /dev/null ; then
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   196
    addImagesDir
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   197
  else
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   198
    printf "%s\n" "$line" >> $IDEA_MISC
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   199
  fi
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   200
done < "$MISC_TEMPLATE"
72e3ae9a25eb 8187444: Forest Consolidation: Make build work
erikj
parents: 47216
diff changeset
   201
37861
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   202
### Compile the custom Logger
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   203
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   204
CLASSES=$IDEA_OUTPUT/classes
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   205
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   206
if [ "x$ANT_HOME" = "x" ] ; then
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   207
   # try some common locations, before giving up
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   208
   if [ -f "/usr/share/ant/lib/ant.jar" ] ; then
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   209
     ANT_HOME="/usr/share/ant"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   210
   elif [ -f "/usr/local/Cellar/ant/1.9.4/libexec/lib/ant.jar" ] ; then
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   211
     ANT_HOME="/usr/local/Cellar/ant/1.9.4/libexec"
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   212
   else
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   213
     echo "FATAL: cannot find ant. Try setting ANT_HOME." >&2; exit 1
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   214
   fi
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   215
fi
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   216
CP=$ANT_HOME/lib/ant.jar
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   217
rm -rf $CLASSES; mkdir $CLASSES
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   218
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   219
if [ "x$CYGPATH" = "x" ] ; then ## CYGPATH may be set in env.cfg
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   220
  JAVAC_SOURCE_FILE=$IDEA_OUTPUT/src/idea/JdkIdeaAntLogger.java
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   221
  JAVAC_CLASSES=$CLASSES
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   222
  JAVAC_CP=$CP
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   223
else
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   224
  JAVAC_SOURCE_FILE=`cygpath -am $IDEA_OUTPUT/src/idea/JdkIdeaAntLogger.java`
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   225
  JAVAC_CLASSES=`cygpath -am $CLASSES`
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   226
  JAVAC_CP=`cygpath -am $CP`
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   227
fi
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   228
53d85619d7fe 8074716: IntelliJ IDEA project support
chegar
parents:
diff changeset
   229
$BOOT_JDK/bin/javac -d $JAVAC_CLASSES -cp $JAVAC_CP $JAVAC_SOURCE_FILE